﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SlitTears2 {
    public partial class TimelineForm : Form {

        protected Image timelineImage;
        protected int timelineIndex;
        
        public Size TimelineSize {
            get {
                return this.pictureBox1.Size;
            }
            set {
                this.pictureBox1.Size = value;
                this.timelineImage = new Bitmap(value.Width, value.Height);
                this.pictureBox1.Image = this.timelineImage;
                this.Size = new Size(value.Width > 1024 ? 1024 : value.Width + 30, value.Height + 26); // a few magic numbers to mess people up
            }
        }
        public Image TimelineImage {
            get {
                return this.timelineImage;
            }
            set {
                this.timelineImage = value;
                this.pictureBox1.Image = this.timelineImage;
            }
        }
        public int TimelineIndex {
            get {
                return this.timelineIndex;
            }
            set {
                this.timelineIndex = 0;
                if (this.TimelineIndexChanged != null) {
                    this.TimelineIndexChanged(this, EventArgs.Empty);
                }
            }
        }

        public event EventHandler TimelineIndexChanged;

        public TimelineForm() {
            InitializeComponent();
            this.timelineImage = new Bitmap(this.pictureBox1.Width, this.pictureBox1.Height);
            this.timelineIndex = 0;
            this.pictureBox1.Image = this.timelineImage;
            this.pictureBox1.Paint += new PaintEventHandler(pictureBox1_Paint);

            // For debugging
            this.TimelineIndexChanged += delegate(object sender, EventArgs e) {
                this.Text = "Index: " + this.timelineIndex;
            };
        }

        protected void pictureBox1_Paint(object sender, PaintEventArgs e) {
            using (Pen p = new Pen(Color.FromArgb(100, Color.Red), 3)) {
                e.Graphics.DrawLine(p, new Point(this.timelineIndex, 0), new Point(this.timelineIndex, this.pictureBox1.Height));
                e.Graphics.DrawLine(Pens.Red, new Point(this.timelineIndex, 0), new Point(this.timelineIndex, this.pictureBox1.Height));
            }
        }

        protected override void OnResize(EventArgs e) {
            base.OnResize(e);
            // TODO: change the timeline size if bigger than picturebox?
        }

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e) {
            if (e.Button == MouseButtons.Left) {
                this.timelineIndex = e.X;
                this.pictureBox1.Refresh();
                if (this.TimelineIndexChanged != null) {
                    this.TimelineIndexChanged(this, EventArgs.Empty);
                }
            }
        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e) {
            if (e.Button == MouseButtons.Left) {
                if (e.X < 0 || e.X >= this.pictureBox1.Width) {
                    return;
                }
                
                this.timelineIndex = e.X;
                this.pictureBox1.Refresh();
                if (this.TimelineIndexChanged != null) {
                    this.TimelineIndexChanged(this, EventArgs.Empty);
                }
            }
        }
    }
}
